#ifndef PROCESSTRACE_H
#define PROCESSTRACE_H

#include <linux/types.h>
#include <linux/list.h>

struct process_trace_entry {
	unsigned char opcode;	/* one of _UTRACE_EVENT_* */
	char comm[TASK_COMM_LEN]; /* XXX: should be in/via trace_entry */
	union {
		struct {
			pid_t child;
			unsigned long flags;
		} trace_clone;
		struct {
			long code;
		} trace_exit;
		struct {
		} trace_exec;
		struct {
			int si_signo;
			int si_errno;
			int si_code;
		} trace_signal;
		struct {
			long callno;
			unsigned long args[6];
		} trace_syscall_entry;
		struct {
			long rc;
			long error;
		} trace_syscall_exit;
	};
};

/* in kernel/trace/trace_process.c */

extern void enable_process_trace(void);
extern void disable_process_trace(void);

#endif /* PROCESSTRACE_H */
